import $ from 'jquery'
import Utils from 'utils'
import Browser from 'browser'
import Testable from './testable'

// TODO change argument from menu_index to parameter name similar to the later forked version
function ParameterMenuTestable(menu_index) {
	this.menu_index = menu_index

	var controls = document.querySelectorAll('.parameter-control')
	if(controls){
		var classes = controls[menu_index].classList
		this.parameter = Array.from(classes.values()).reduce(function(a, b){ return b.split('-').length && b.split('-')[1]})
	}
}

ParameterMenuTestable.prototype = {
	select_item: function(item_index) {
		var self = this, test = this.test

		test.assert(!!this.parameter, 'parameter is not set')

		function menu_item(){
			var menu = $($('body > .parameter-menu > ul')[self.menu_index])
			return menu.find('li:eq(' + item_index + ')')
		}

		return new Promise(function(resolve){
			test.wait_for(
				function(){ return self.n_items() },
				'select_item: waiting for items'
			)
			.then(function(){
				test.assert(item_index < self.n_items(), 'index too high: ' + item_index + '/' + self.n_items())
				test.assert(!!menu_item().length, 'cannot find menu item')
				test.assert(menu_item().length === 1, 'menu item length ' + menu_item().length)

				var uuid = self.uuid()

				menu_item().click()

				test.try(
					// MSIE is returning incorrect values for the ui-icon-check query
					function(){ return Browser.msie || (self.selected_item() === item_index) },
					function(){ return 'PMTestable: new selection: ' + self.selected_item() + ' (expected ' + item_index + ')'}
				)
				.then(function(){
					console.log('uid changed?', uuid,  self.uuid())
					menu_item().click()
				})
				.then(test.wait_for3(
					// MSIE is returning incorrect values for the ui-icon-check query
					function(){ return Browser.msie || (self.selected_item() === item_index) },
					function(){ return 'PMTestable: new selection: ' + self.selected_item() + ' (expected ' + item_index + ')'}
				))
				.then(resolve)
			})
		})
	},

	selected_item: function() {
		return this.menu().find('> li').toArray().findIndex(function(item, i) {
			return $(item).find('.ui-icon-check').length
		})
	},

	n_items: function() {
		return this.menu().find('> li').length
	},

	menu: function() {
		return $($('body > .parameter-menu > ul')[this.menu_index])
	},

	uuid: function(){
		return this.control().data('uiParameter' + Utils.ucfirst(this.parameter)).uuid
	},

	control: function(){
		return $('.parameter-control.parameter-' + this.parameter)
	}
}

export default ParameterMenuTestable
