define(['jquery', 'bus', '../widgets/widget'], function($, Bus, DashboardWidget){

	function WidgetTestable(w, dt){
		this.w = w // TODO support creation of new widget in constructor here
		this.dt = dt
		this.test = dt.test
	}

	WidgetTestable.prototype = {
		add_help_panel: function(){
			var self = this;

			self.test.assert_no_element('.help-panel')

			return new Promise(function(resolve){
				var button = self.w.element.find('.ui-icon-help:first')
				var id = parent
				button.click()
				self.test.wait_for('.help-panel').then(function(){
					var panel = $('.help-panel')
					self.test.assert(panel.attr('name') === self.name(), 'id "' + panel.attr('name') + '" (expected ' + self.name() + ')')
					self.test.wait_find(panel, '.content.markup').then(function(content){
						panel.find('.close').click()
						self.test.wait_for_remove('.help-panel').then(function(){
							resolve()
						})
					})
				})
			})
		},

		name: function(){
			return this.w.options.name;
		},

		title: function(){
			return this.w.options.title;
		},

		collapse: function(){
			var self = this

			return new Promise(function(resolve){
				var button = self.w.element.find('.ui-button .ui-icon-triangle-1-n:first')
				self.test.assert(button.length === 1)
				button.click()
				self.test.wait_for(
					function(){
						return self.w.element.height()  < 60
					},
					function(){ return 'collapse: height ' + self.w.element.height() + ' expected < 60' }
				).then(function(){
					resolve()
				})
			})
		},

		uncollapse: function(){
			var self = this

			return new Promise(function(resolve){
				var button = self.w.element.find('.ui-button .ui-icon-triangle-1-s:first')
				self.test.assert(button.length === 1, 'uncollapse: button ' + button.length)
				button.click()
				self.test.wait_for(
					function(){
						return self.w.element.height() > 150
					},
					function(){ return 'uncollapse: height ' + self.w.element.height() + ' expected > 150' }
				).then(function(){
					resolve()
				})
			})
		}
	}

	return WidgetTestable
});
