/*
 *  TODO
 *     - ensure that the Epsgram test is actually run (it must currently be on the correct page)
 *     - add test for city finder to the Epsgram test
 *
 *     - 'Test parameters preserved' timeout
 *          .inform-dialogue: The chart could not be produced (504 Gateway timeout)
 *             we should:
 *               1- ensure that the test does not finish before the gateway timeout message is delivered (timeout is 30s on stage)
 *               2- check that 504 is captured by the test, and possibly also to either replace inform-dialogue with notify, or check for .inform-dialogue in the test.
 */
import $ from 'jquery'
import Bus from 'bus'
import Unit from 'unit'
import Utils from 'utils'
import Tests from 'test-lib'
import Testable from '../testable'
import GridTestable from 'grid/testable'
import router from 'chart-app/router'
import qs from 'page/query'
import Products from 'grid/products'
import User from 'user_info'

var dont_run = [
	/*
	'Test login',
	'Test parameter menu',
	*/
]

new Tests([
	{
		name: 'Test login',
		start: function(){
			this.assert_no_element('a[href="/sso/login/openid-connect"]').finished()
		}
	},

	{
		name: 'Test parameter menu',
		start: function() {
			var test = Testable.test = this

			test.pseries([
				function(){ return test.sleep(2000) },
				Testable.test_tcyclone_products,
				Testable.tcyclone_base_time.bind(Testable),
			])
		}
	}
]).dont_run(dont_run).run()
